# Warehouse Management (WM)

## What To Expect For Other Groups
#### API Contracts
- **No APIs made for public consumption.**

#### Inventory, Pricing, & Promotions
- Warehouse Management (WM) to provide Kafka message upon order fulfillment or cancellation.

#### E-Commerce
- None

#### Order Management
- Warehouse Management (WM) to expect Kafka message upon order creation.
- WM to provide Kafka message upon order fulfillment or cancellation.

---

## Details
#### Schema
```
{
    _id: String
    orderId: String
    status: String "unfulfilled" (default) > "fulfilled"/"cancelled"
    orderObject?: (will have it on initial Kafka message, not sure if we need to store this)
}
```

#### Workflow
- Warehouse Management (WM) expects an Order object (?) from Order Management (OM) on order placement in Kafka.
- On receipt of an Order object, WM will create a warehouse order entry in database with a status of "unfulfilled."
- In the WM UI, a warehouse manager will have the ability to fulfill or cancel unfulfilled orders.
- When an order is marked **"fulfilled"** or **"cancelled"**, a Kafka message will be sent to be consumed.

#### UI
- Login
- Order status update screen mark orders as fulfilled or cancelled
- Order search
- Order information page

#### API Documentation
https://documenter.getpostman.com/view/7402212/TzRNGATe
