import * as OrderAPIUtil from '../util/orders_api_util';

export const RECEIVE_ORDERS = 'RECEIVE_ORDERS';
export const RECEIVE_ORDER = 'RECEIVE_ORDER';
export const UPDATE_ORDER = 'UPDATE_ORDER';

const receiveOrders = (orders) => ({
  type: RECEIVE_ORDERS,
  orders,
})

const receiveOrder = (order) => ({
  type: RECEIVE_ORDER,
  order,
})

const updateOrder = (order) => ({
  type: UPDATE_ORDER,
  order,
})

export const fetchOrders = () => (dispatch) => {
  OrderAPIUtil.getOrders()
    .then(res => {
      dispatch(receiveOrders(res))
    });
}

export const createOrder = (order) => (dispatch) =>
  OrderAPIUtil.createOrder(order)
    .then(res => {
      dispatch(receiveOrder(res))
    });

export const editOrder = (order) => (dispatch) => {
  OrderAPIUtil.editOrder(order)
    .then(res => {
      dispatch(updateOrder(res))
    });
}