import {
  RECEIVE_ORDER,
  RECEIVE_ORDERS,
  UPDATE_ORDER,
} from "../../actions/order_actions";

const initialState = {
  byId: {},
  allIds: [],
};

const OrdersReducer = (oldState = initialState, action) => {
  Object.freeze(oldState);
  const newState = { ...oldState };
  const order = action.order || null;
  
  switch (action.type) {
    case RECEIVE_ORDERS:
      const orderState = {
        byId: {},
        allIds: [],
      };
      Object.keys(action.orders).forEach( wareId => {
        orderState.allIds.push(wareId);
        orderState.byId[wareId] = action.orders[wareId];
      })
      return orderState;
    case RECEIVE_ORDER:
      newState.byId[order.id] = order;
      newState.allIds.push(order.id);
      return newState;
    case UPDATE_ORDER:
      newState.byId[order.id] = order;
      return newState;
    default:
      return oldState;
  }
};

export default OrdersReducer;
