package com.ascendfinalproject.warehouse.controllers;

import com.ascendfinalproject.warehouse.models.WarehouseOrder;
import com.ascendfinalproject.warehouse.services.WarehouseOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping(value = "/api")
public class WarehouseController {

  @Autowired
  WarehouseOrderService orderService;

  @CrossOrigin
  @GetMapping(value = "/orders")
  public Flux<WarehouseOrder> getOrders() {
    return orderService.getOrders();
  }

  @CrossOrigin
  @GetMapping("/orders/{id}")
  public Mono<WarehouseOrder> findStudent(@PathVariable String id){
    return orderService.findOrderById(id);
  }

  @CrossOrigin
  @PostMapping(value = "/orders")
  public Mono<WarehouseOrder> createOrder(@RequestBody WarehouseOrder order) {
    return orderService.createOrder(order);
  }

  @CrossOrigin
  @PutMapping(value = "/orders/{id}")
  public Mono<WarehouseOrder> updateOrder(@RequestBody WarehouseOrder order, @PathVariable(value = "id") String id) {
    return orderService.updateOrder(order, id);
  }

}
