package com.ascendfinalproject.warehouse.services;

import com.ascendfinalproject.warehouse.models.WarehouseOrder;
import com.ascendfinalproject.warehouse.repositories.WarehouseOrderRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class WarehouseOrderService {

  @Autowired
  WarehouseOrderRepository orderRepository;

  public Mono<WarehouseOrder> findOrderById(String id) {
    return orderRepository.findById(id);
  }

  public Flux<WarehouseOrder> getOrders() {
      return orderRepository.findAll();
//    OrderResponse response = new OrderResponse();
//    orderRepository.findAll()
//            .flatMap(order -> {
//              response.appendId(order.getId());
//              response.getById().put(order.getId(), order);
//            });
//
//    return response;
  }

  public Mono<WarehouseOrder> createOrder(WarehouseOrder order) {
    return orderRepository.save(order);
  }

  public Mono<WarehouseOrder> updateOrder(WarehouseOrder order, String id) {
    return orderRepository.findById(id)
            .flatMap(existingOrder -> {
              existingOrder.setOrderId(order.getOrderId());
              existingOrder.setStatus(order.getStatus());
              return orderRepository.save(existingOrder);
            });

  }

}
